#ifndef INSTR_IPMNGT_HPP
#define INSTR_IPMNGT_HPP

#include <oh/instruction.hpp>

class Sis : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class Nop : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class Ret : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class Jmp : public Instruction {
public:
  Jmp(int rel = 0);
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
private:
  int M_rel;
};

class Call : public Instruction {
public:
  Call(int rel = 0);
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
private:
  int M_rel;
};

#endif // INSTR_IPMNGT_HPP
