#ifndef INSTR_LS_HPP
#define INSTR_LS_HPP

#include <oh/instruction.hpp>

class Load_A_Addr : public Instruction {
public:
  Load_A_Addr(int addr);
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
private:
  int M_addr;
};

class Load_B_Addr : public Instruction {
public:
  Load_B_Addr(int addr);
  virtual void execute(Memory& mem, Internals& internals);  
  virtual void disasm(std::ostream&) const;
private:
  int M_addr;
};

class Store_Addr_A : public Instruction {
public:
  Store_Addr_A(int addr);
  virtual void execute(Memory& mem, Internals& internals);  
  virtual void disasm(std::ostream&) const;
private:
  int M_addr;
};

class Store_Addr_B : public Instruction {
public:
  Store_Addr_B(int addr);
  virtual void execute(Memory& mem, Internals& internals);  
  virtual void disasm(std::ostream&) const;
private:
  int M_addr;
};

class Load_A_Imm : public Instruction {
public:
  Load_A_Imm(int imm);
  virtual void execute(Memory& mem, Internals& internals);  
  virtual void disasm(std::ostream&) const;
private:
  int M_imm;
};

class Load_B_Imm : public Instruction {
public:
  Load_B_Imm(int imm);
  virtual void execute(Memory& mem, Internals& internals);  
  virtual void disasm(std::ostream&) const;
private:
  int M_imm;
};

#endif // INSTR_LS_HPP
