#ifndef INSTR_UAL_HPP
#define INSTR_UAL_HPP

#include <oh/instruction.hpp>

class Load_W_A : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class Load_W_B : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class Load_A_W : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class Load_B_W : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class IO_From_A : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class IO_From_B : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class Or_A_B : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class And_A_B : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class Xor_A_B : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class Not_A : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class Not_B : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class Add_A_B : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class Sub_A_B : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class Shl_A : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class Shl_B : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class Shr_A : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};

class Shr_B : public Instruction {
public:
  virtual void execute(Memory& mem, Internals& internals);
  virtual void disasm(std::ostream&) const;
};



#endif // INSTR_UAL_HPP
