#ifndef INSTRUCTION_HPP
#define INSTRUCTION_HPP

#include <iosfwd>
#include <oh/memory.hpp>
#include <oh/internals.hpp>

class Instruction {
public:
  virtual ~Instruction();
  virtual void execute(Memory& mem, Internals& internals) = 0;
  virtual void disasm(std::ostream&) const = 0;
};

std::ostream& operator<<(std::ostream&, const Instruction&);

#endif // INSTRUCTION_HPP
