#include <iostream>
#include <iomanip>
#include <oh/stream.hpp>

int Verbosity::S_value = Verbosity::DEBUG; // just for developping

void Verbosity::set(int verbosity) {
  Verbosity::S_value = verbosity;
}

bool Verbosity::verbose() {
  return Verbosity::S_value >= Verbosity::VERBOSE;
}

bool Verbosity::debug() {
  return Verbosity::S_value >= Verbosity::DEBUG;
}

std::ostream& info(std::ostream& os) {
  return os << "( ) ";
}

std::ostream& error(std::ostream& os) {
  return os << "(E) ";
}

std::ostream& verbose(std::ostream& os) {
  return os << "(V) ";
}

std::ostream& debug(std::ostream& os) {
  return os << "(D) ";
}

std::ostream& nl(std::ostream& os) {
  return os << '\n';
}

struct _Addr address(int __a) {
  struct _Addr __x;
  __x._M_a = __a;
  return __x;
}

std::ostream& operator<<(std::ostream& os, const struct _Addr a) {
  os << "0x";
  os << std::hex;
  os << std::setw(2);
  os << std::setfill('0');
  return os << a._M_a;
}

struct _Imm immediate(int __i) {
  struct _Imm __x;
  __x._M_i = __i;
  return __x;
}

std::ostream& operator<<(std::ostream& os, const struct _Imm i) {
  os << std::dec;
  return os << i._M_i;
}

struct _Rel relative(int __r) {
  struct _Rel __x;
  __x._M_r = __r;
  return __x;
}

inline int stream_sign_extend(int rel) {
  if((rel & 0x20) != 0) {
    return (rel + 0xC0) - 256;
  }
  return rel;
}

std::ostream& operator<<(std::ostream& os, const struct _Rel r) {
  os << std::dec;
  return os << stream_sign_extend(r._M_r);
}

